=== src/gfx/CMakeLists.txt ===
# ASEPRITE
# Copyright (C) 2001-2012  David Capello

add_library(gfx-lib
  hsv.cpp
  rgb.cpp
  transformation.cpp)
