=== src/she/CMakeLists.txt ===
# SHE
# Copyright (C) 2012  David Capello

add_library(she
  she_alleg4.cpp)
