=== src/ui/CMakeLists.txt ===
# ASEPRITE
# Copyright (C) 2001-2012  David Capello

add_library(ui-lib
  accelerator.cpp
  alert.cpp
  box.cpp
  button.cpp
  clipboard.cpp
  combobox.cpp
  component.cpp
  cursor.cpp
  custom_label.cpp
  draw.cpp
  entry.cpp
  event.cpp
  font.cpp
  fontbmp.cpp
  graphics.cpp
  grid.cpp
  gui.cpp
  image_view.cpp
  intern.cpp
  label.cpp
  link_label.cpp
  listbox.cpp
  manager.cpp
  menu.cpp
  message.cpp
  message_loop.cpp
  overlay.cpp
  overlay_manager.cpp
  paint_event.cpp
  popup_window.cpp
  preferred_size_event.cpp
  property.cpp
  rect.cpp
  region.cpp
  scroll_bar.cpp
  separator.cpp
  slider.cpp
  splitter.cpp
  system.cpp
  textbox.cpp
  theme.cpp
  timer.cpp
  tooltips.cpp
  view.cpp
  viewport.cpp
  widget.cpp
  window.cpp)
