=== src/undo/CMakeLists.txt ===
# ASEPRITE Undo Library
# Copyright (C) 2001-2012  David Capello

add_library(undo-lib
  undo_history.cpp
  undoers_stack.cpp)
