=== debian/changelog ===
aseprite (0.9.5-3) unstable; urgency=low

  [ Ilya Barygin ]
  * Fix FTBFS with --as-needed linker option. (Closes: #692302)

  [ Daniel T Chen ]
  * Added missing X11 lib to link, fixing FTBFS. (Closes: #713705)

  [ Tobias Hansen ]
  * Include all patches from Ubuntu revision 0.9.5-2ubuntu2, see above.
  * Bump Standards-Version to 3.9.4, no changes needed.

 -- Tobias Hansen <thansen@debian.org>  Sat, 22 Jun 2013 18:59:05 +0200

aseprite (0.9.5-2) unstable; urgency=low

  * debian/patches/undef-major-and-minor.patch:
    - Added. Undef major and minor macros to build on kfreebsd and Hurd.

 -- Tobias Hansen <thansen@debian.org>  Wed, 03 Oct 2012 19:58:21 +0200

aseprite (0.9.5-1) unstable; urgency=low

  * Initial release (Closes: #596241)

 -- Tobias Hansen <thansen@debian.org>  Tue, 25 Sep 2012 01:32:21 +0200
